---
title: My infrastructure
description: ""
date: 2024-10-13T19:53:17.597Z
preview: ""
draft: true
tags: []
categories: []
---

Any website or server has to have some type of infrastructure.

This infrastructure may be small or large, depending on the organization. For example, Microsoft has many large systems and services that require upkeep and maintenance.

A person may also run hosts and services. While these don't have the same scale as a big company, the hosts still need to be managed.

In this post, I will detail how some of the providers and the software I use.

## Providers

Because I am a student, I don't have the resources for hosting critical services myself. Ideally, I would love to host my infrastructure on hosts I own, but that's not possible. Instead, I rent servers and services from cloud providers. These providers are as follows:

- Hetzner - a German company

  - They provide a dedicated 2 vCPU server with 8 GB RAM. 
  - They also provide a Storage Box that is used for various need such as backups and general storage.

- Contabo - a German company
  - They currently provide one 6 vCPU, 16 GB RAM server.

- Backblaze - a US company
  - They are a storage provider specializing in S3 storage.
  - They provide storage for several services as well as general storage.

## Software

Now I will detail the software and the host it runs on.

- Gitea
  - Host: Hetzner
  - What is it: Self-hosted Git hosting
  - This runs in Docker and hosts my own private and public repos.

- Woodpecker CI/CD
  - Host: Contabo
  - What is it: A continuous integration/deployment server
  - This runs all my pipelines for my repos. I deploy this blog and my landing page using this service.

- Stalwart Mail
  - Host: Hetzner and Contabo
  - What is it: An email server
  - This runs on two hosts for redundancy. The database only runs on a single host for now.

- Linkwarden
  - Host: Contabo
  - What is it: A link aggregator - think bookmarks not hosted locally
  - This is a game-changer because I can keep all my information saved in a central database.

- Peertube
  - Host: Contabo
  - What is it: A video hosting platform
  - I use it instead of publicly accessible platforms.

- Nextcloud
  - Host: Contabo
  - What is it: File-sharing service
  - I use it to have access to files on-the-go.
  